<script lang="ts">
import Vue from 'vue';
import DemoModal from '~/components/common/demo-modal.vue';

export default Vue.extend({
  name: 'DemoCta',
  components: { DemoModal },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  methods: {
    openModal() {
      this.modal.open = true;

      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <section
    :id="data.id"
    class="demo-cta-section"
    :class="`demo-cta-section--${data.layout}`"
  >
    <div class="demo-cta" :class="`demo-cta--${data.layout}`">
      <SlpRow class="demo-cta__text">
        <SlpTypography
          variant="heading3-bold"
          tag="h4"
          class="demo-cta__header"
          >{{ data.header }}</SlpTypography
        >
        <SlpTypography
          variant="p"
          tag="p"
          class="demo-cta__subheader slp-mb-24"
          >{{ data.subheader }}</SlpTypography
        >
      </SlpRow>
      <SlpRow>
        <div class="video">
          <div
            class="image__container"
            :data-ga-location="data.launchButton.data_ga_location"
            :data-ga-name="data.launchButton.data_ga_name"
            @click="openModal"
          >
            <img
              class="demo-thumbnail"
              :src="data.demo.video.thumbnail"
              :alt="data.demo.video.altText"
            />
            <SlpButton variant="secondary" class="slp-mt-32 demo-button">
              <SlpIcon
                :name="data.launchButton.icon_name"
                :variant="data.launchButton.icon_variant"
                alt="laptop-play-video"
              />{{ data.launchButton.text }}</SlpButton
            >
          </div>
        </div>

        <DemoModal
          v-show="modal.open"
          :data="data.demo"
          :visible="modal.open"
          @close="closeModal"
        >
        </DemoModal>
      </SlpRow>
    </div>
  </section>
</template>

<style scoped lang="scss">
.demo-cta-section {
  position: relative;
  max-width: 100%;
  overflow-x: clip;
  margin-bottom: 96px;
  .video {
    max-width: 1150px;
    height: fit-content;
    display: flex;
    flex: 2 1 0;
    .image__container {
      display: flex;
      position: relative;
      border-radius: 4px;
      border: 0.5px solid black;
      overflow: hidden;
      &::before {
        content: '';
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background: linear-gradient(
          to bottom,
          rgba(110, 73, 203, 0.3) rgba(255, 212, 216, 0.45)
        );
        opacity: 0;
        transition: opacity 0.3s ease-in-out;
      }
      &:hover::before {
        opacity: 1;
      }
    }
    .demo-thumbnail {
      max-width: 100%;
      display: block;
      height: auto;
      filter: blur(1px);
      z-index: 1;
      transition: filter 0.3s ease-in-out;
      &:hover {
        z-index: 0;
        cursor: pointer;
        background: linear-gradient(
          to bottom,
          rgba(110, 73, 203, 0.3) rgba(255, 212, 216, 0.45)
        );
      }
    }

    .demo-button {
      position: absolute;
      top: 37%;
      left: 50%;
      transform: translate(-50%, -50%);
      z-index: 2;
      border-radius: 30px;
      min-width: 171px;
      &:hover {
        box-shadow: 0 2px 50px rgba($color-surface-700, 0.25);
      }
      .slp-icon {
        margin-right: 5px;
        width: 24px;
        height: 24px;
      }
    }
  }
  &__link {
    display: flex;
    align-items: center;
    margin: $spacing-32 0 $spacing-8;
    color: $color-text-300;
  }

  &__header {
    margin-bottom: $spacing-24;
  }

  &--dark-bg {
    // Full viewport background trick
    background-color: $color-surface-800;
    border-radius: 8px;
    padding: $spacing-48;
    .demo-cta__text {
      margin-right: $spacing-32;
    }
    .demo-cta--dark-bg {
      display: flex;
      flex-direction: row;
      @media (max-width: $breakpoint-sm) {
        display: flex;
        flex-direction: column;

        .image__container {
          max-width: 100%;
        }
        .demo-button {
          top: 30%;
        }
      }
    }
    @media (max-width: $breakpoint-sm) {
      padding: $spacing-32;
    }
  }

  &--dark-shortened {
    background: $color-surface-800;
    padding: $spacing-32 0;
    margin: 48px auto 0 auto;
    @media (min-width: $breakpoint-md) {
      padding: $spacing-96 0 0 0;
      margin: 0 auto;
    }

    &:after {
      background: #f6f3fe;
      content: '';
      left: -50vw;
      height: 100%;
      position: absolute;
      top: 0;
      width: 200vw;
      z-index: -1;
    }
  }

  &--light {
    margin-top: $spacing-32;
    .reports {
      margin-top: $spacing-96;
      .card {
        background: $color-surface-800;
        .demo-cta__description {
          font-size: 20px;
          font-weight: 600;
          line-height: 24px;
        }

        .demo-cta__link {
          margin-top: $spacing-16;
        }
      }
    }
  }
}
</style>
